
// ========== Generated With RFC Amalgamator v1.0 ==========


#include"rfc_amalgamated.h"


// =========== KApplication.cpp ===========

/*
    RFC - KApplication.cpp
    Copyright (C) 2013 CrownSoft
  
    This software is provided 'as-is', without any express or implied
    warranty.  In no event will the authors be held liable for any damages
    arising from the use of this software.

    Permission is granted to anyone to use this software for any purpose,
    including commercial applications, and to alter it and redistribute it
    freely, subject to the following restrictions:

    1. The origin of this software must not be misrepresented; you must not
       claim that you wrote the original software. If you use this software
       in a product, an acknowledgment in the product documentation would be
       appreciated but is not required.
    2. Altered source versions must be plainly marked as such, and must not be
       misrepresented as being the original software.
    3. This notice may not be removed or altered from any source distribution.
      
*/


KApplication::KApplication()
{
}

int KApplication::Main(KString **argv,int argc)
{
	return 0;
}

KApplication::~KApplication()
{
}

// =========== rfc.cpp ===========

/*
    RFC - rfc.cpp
    Copyright (C) 2013 CrownSoft
  
    This software is provided 'as-is', without any express or implied
    warranty.  In no event will the authors be held liable for any damages
    arising from the use of this software.

    Permission is granted to anyone to use this software for any purpose,
    including commercial applications, and to alter it and redistribute it
    freely, subject to the following restrictions:

    1. The origin of this software must not be misrepresented; you must not
       claim that you wrote the original software. If you use this software
       in a product, an acknowledgment in the product documentation would be
       appreciated but is not required.
    2. Altered source versions must be plainly marked as such, and must not be
       misrepresented as being the original software.
    3. This notice may not be removed or altered from any source distribution.
      
*/


KComponent *currentComponent=0;
HHOOK wnd_hook=0;
CRITICAL_SECTION g_csComponent; // guard currentComponent!

const wchar_t* RFCPropText_Object=L"RFC";
const wchar_t* RFCPropText_OldProc=L"RFCOldProc";
const wchar_t* RFCPropText_ClsName=L"RFCClsName";

static volatile int refCount=0;

LRESULT CALLBACK RFCCTL_CBTProc(int nCode,WPARAM wParam,LPARAM lParam)
{
	if(nCode < 0)
        return CallNextHookEx(wnd_hook, nCode, wParam, lParam);

	if(nCode==HCBT_CREATEWND){
		HWND hwnd=(HWND)wParam;
		SetPropW(hwnd,RFCPropText_Object,(HANDLE)currentComponent);
		FARPROC lpfnOldWndProc=(FARPROC)GetWindowLong(hwnd,GWL_WNDPROC);
		SetPropW(hwnd,RFCPropText_OldProc,(HANDLE)lpfnOldWndProc);
		SetPropW(hwnd,RFCPropText_ClsName,(HANDLE)(const wchar_t*)currentComponent->GetComponentClassName());

		SetWindowLongW(hwnd,GWL_WNDPROC,(LONG)GlobalWnd_Proc); // subclassing...
		
		return 0;
	}

	// Call the next hook, if there is one
    return CallNextHookEx(wnd_hook, nCode, wParam, lParam);
}



LRESULT CALLBACK GlobalWnd_Proc(HWND hwnd,UINT msg,WPARAM wParam,LPARAM lParam)
{

	KComponent *component=(KComponent*)GetPropW(hwnd, RFCPropText_Object);

	if(!component){ // just for safe!
		return DefWindowProcW( hwnd, msg, wParam, lParam );
	}

	if(!component->GetHWND()) // window recieve msg for the first time!
		component->SetHWND(hwnd);

	if(msg==WM_NCDESTROY){
		RemovePropW(hwnd,RFCPropText_Object);
		RemovePropW(hwnd,RFCPropText_ClsName);
		FARPROC lpfnOldWndProc=(FARPROC)GetPropW(hwnd, RFCPropText_OldProc);
		if(lpfnOldWndProc)
		{
			RemovePropW(hwnd,RFCPropText_OldProc);
			SetWindowLongW(hwnd,GWL_WNDPROC,(LONG)lpfnOldWndProc); // restore default wnd proc!
			return CallWindowProcW((WNDPROC)lpfnOldWndProc, hwnd, msg, wParam,lParam);
		}
		
	}

	return component->WindowProc(hwnd,msg,wParam,lParam);
}

HWND CreateRFCComponent(KComponent* component)
{
	// we make thread safe this function!

	EnterCriticalSection(&g_csComponent);

	currentComponent=component;

	wnd_hook=SetWindowsHookExW(WH_CBT,&RFCCTL_CBTProc,0,GetCurrentThreadId());

	HWND hwnd=CreateWindowExW(component->GetExStyle(),(const wchar_t*)component->GetComponentClassName(),(const wchar_t*)component->GetText(),component->GetStyle(),component->GetX(),component->GetY(),component->GetWidth(),component->GetHeight(),component->GetParentHWND(),0,KPlatformUtil::GetInstance()->GetAppInstance(),0);

	UnhookWindowsHookEx(wnd_hook);

	LeaveCriticalSection(&g_csComponent);

	return hwnd;
}

void DoMessagePump(bool handleTabKey)
{
	MSG msg;
	
	while (GetMessageW(&msg, NULL, NULL, NULL)) 
	{
		if(handleTabKey)
		{
			if(msg.message==WM_KEYDOWN)
			{
				if(VK_TAB==msg.wParam) // looking for TAB key!
				{
					if(msg.hwnd)
					{
						HWND parentHWND=GetParent(msg.hwnd);
						if(!parentHWND) // nothing selected! (top-level window)
						{
							HWND nextControl=GetNextDlgTabItem(msg.hwnd,NULL,FALSE);
							if(nextControl)
							{
								SetFocus(nextControl);
								continue; // don't pass this message!
							}
						}else // user has already selected component!
						{
							HWND nextControl=GetNextDlgTabItem(parentHWND,msg.hwnd,FALSE);
							if(nextControl)
							{
								if((GetKeyState(VK_CONTROL) & 0x8000)==0) // user is not hold ctrl key!
								{
									SetFocus(nextControl);
									continue; // don't pass this message!
								}
							}
						}
					}
				}
			}
		}
		TranslateMessage( &msg );
		DispatchMessageW( &msg );
	} 
}

DWORD WINAPI GlobalThread_Proc(LPVOID lpParameter)
{
	if(lpParameter==0) // for safe!
		return 0;

	KThread* thread=(KThread*)lpParameter;
	if(thread)
	{
		thread->SetHandle(GetCurrentThread());
		thread->Run();
	}

	return 0;	
}

bool CreateRFCThread(KThread* thread)
{
	if(thread)
	{
		HANDLE handle=CreateThread(NULL,NULL,GlobalThread_Proc,thread,0,NULL);
		if(handle)
			return true;
	}
	return false;
}

int HotPlugAndRunDialogBox(WORD resourceID,HWND parentHwnd,KComponent* component)
{
	return (int)DialogBoxParam(KPlatformUtil::GetInstance()->GetAppInstance(),MAKEINTRESOURCE(resourceID),parentHwnd,GlobalDlg_Proc,(LPARAM)component);
}

BOOL CALLBACK GlobalDlg_Proc(HWND hwndDlg,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
	if(uMsg==WM_INITDIALOG)
	{
		KComponent* comp=dynamic_cast<KComponent*>((KComponent*)lParam);
		if(comp)
		{
			comp->HotPlugInto(hwndDlg);
		}
		return FALSE;
	}
	return FALSE;
}

void InitRFC(HINSTANCE hInstance)
{
	if(!refCount)
	{
		// use low fragmentation heap feature if available. (only for M$ compilers)
		#ifdef _MSC_VER
			#ifndef NO_LFH_OPTION
			typedef enum _HEAP_INFORMATION_CLASS {   
				HeapCompatibilityInformation   
			} HEAP_INFORMATION_CLASS;
			typedef BOOL (WINAPI* PFN_HeapSetInformation)(HANDLE HeapHandle,HEAP_INFORMATION_CLASS HeapInformationClass,PVOID HeapInformation,SIZE_T HeapInformationLength);

			HMODULE kernelMod = GetModuleHandleW(L"kernel32" );
			if(kernelMod)
			{
				PFN_HeapSetInformation pfnHeapSetInformation = (PFN_HeapSetInformation) GetProcAddress( kernelMod, "HeapSetInformation" );
				if(pfnHeapSetInformation)
				{
					ULONG HeapInformation=2; // HEAP_LFH = 2
					HANDLE hHeap = HeapCreate(0, 0, 0);
					(*pfnHeapSetInformation)(hHeap,HeapCompatibilityInformation,&HeapInformation,sizeof(ULONG));
					#if _MSC_VER >= 1300 // no way to get the pointer to the CRT heap in VC 6.0 (_crtheap)
					(*pfnHeapSetInformation)((HANDLE)_get_heap_handle(), HeapCompatibilityInformation, &HeapInformation, sizeof(ULONG));
					#endif
				}
			}

			#endif
		#endif

		KPlatformUtil::GetInstance()->SetAppInstance(hInstance); // create instance for first time & initialize Utility class!
		
		INITCOMMONCONTROLSEX icx;
		icx.dwSize=sizeof(INITCOMMONCONTROLSEX);
		icx.dwICC=ICC_WIN95_CLASSES;
		InitCommonControlsEx(&icx);

		InitializeCriticalSection(&g_csComponent);
	}
	++refCount;
}

void DeInitRFC()
{
	--refCount;
	if(!refCount)
	{
		DeleteCriticalSection(&g_csComponent);

		// delete all singletons!
		delete KFont::GetDefaultFont();
		delete KPlatformUtil::GetInstance();
	}
}

// =========== KPlatformUtil.cpp ===========

/*
    RFC - KPlatformUtil.cpp
    Copyright (C) 2013 CrownSoft
  
    This software is provided 'as-is', without any express or implied
    warranty.  In no event will the authors be held liable for any damages
    arising from the use of this software.

    Permission is granted to anyone to use this software for any purpose,
    including commercial applications, and to alter it and redistribute it
    freely, subject to the following restrictions:

    1. The origin of this software must not be misrepresented; you must not
       claim that you wrote the original software. If you use this software
       in a product, an acknowledgment in the product documentation would be
       appreciated but is not required.
    2. Altered source versions must be plainly marked as such, and must not be
       misrepresented as being the original software.
    3. This notice may not be removed or altered from any source distribution.
      
*/


KPlatformUtil* KPlatformUtil::_instance=0;

KPlatformUtil::KPlatformUtil()
{
	timerCount=0;
	menuItemCount=0;
	classCount=0;
	hInstance=0;
	InitializeCriticalSection(&g_csCount);
	menuItemList=new KPointerList<KMenuItem*>();
	timerList=new KPointerList<KTimer*>();
}

KPlatformUtil* KPlatformUtil::GetInstance()
{
	if(_instance)
		return _instance;
	_instance=new KPlatformUtil();
	return _instance;
}

void KPlatformUtil::SetAppInstance(HINSTANCE hInstance)
{
	this->hInstance=hInstance;
}

HINSTANCE KPlatformUtil::GetAppInstance()
{
	return hInstance;
}

UINT KPlatformUtil::GenerateMenuItemID(KMenuItem *menuItem)
{
	EnterCriticalSection(&g_csCount);
	menuItemCount++;
	menuItemList->AddPointer(menuItem);
	LeaveCriticalSection(&g_csCount);
	return menuItemCount+30000;
}

KMenuItem* KPlatformUtil::GetMenuItemByID(UINT id)
{
	return menuItemList->GetPointer(id-30001);
}

KString KPlatformUtil::GenerateClassName()
{
	EnterCriticalSection(&g_csCount);
	static wchar_t className[32];
	swprintf(className,32,L"RFC_%d",GetTickCount()+classCount);
	classCount++;
	LeaveCriticalSection(&g_csCount);
	return KString(className);
}

UINT KPlatformUtil::GenerateTimerID(KTimer *timer)
{
	EnterCriticalSection(&g_csCount);
	timerCount++;
	timerList->AddPointer(timer);
	LeaveCriticalSection(&g_csCount);
	return timerCount+1000;
}

KTimer* KPlatformUtil::GetTimerByID(UINT id)
{
	return timerList->GetPointer(id-1001);
}

KPlatformUtil::~KPlatformUtil()
{
	delete menuItemList;
	delete timerList;
	DeleteCriticalSection(&g_csCount);
}

// =========== KThread.cpp ===========

/*
    RFC - KThread.cpp
    Copyright (C) 2013 CrownSoft
  
    This software is provided 'as-is', without any express or implied
    warranty.  In no event will the authors be held liable for any damages
    arising from the use of this software.

    Permission is granted to anyone to use this software for any purpose,
    including commercial applications, and to alter it and redistribute it
    freely, subject to the following restrictions:

    1. The origin of this software must not be misrepresented; you must not
       claim that you wrote the original software. If you use this software
       in a product, an acknowledgment in the product documentation would be
       appreciated but is not required.
    2. Altered source versions must be plainly marked as such, and must not be
       misrepresented as being the original software.
    3. This notice may not be removed or altered from any source distribution.
      
*/



KThread::KThread()
{
	handle=0;
	isThreadRunning=false;
	threadShouldStop=false;
}

void KThread::SetHandle(HANDLE handle)
{
	this->handle=handle;
}

HANDLE KThread::GetHandle()
{
	return handle;
}

void KThread::Run()
{
	/*

	while(!threadShouldStop)
	{
		// your code goes here...
	}
	isThreadRunning=false;

	*/
}

bool KThread::IsThreadRunning()
{
	return isThreadRunning;
}

void KThread::ThreadShouldStop()
{
	threadShouldStop=true;
}

void KThread::WaitUntilThreadFinish()
{
	while(isThreadRunning) // wait until thread stop!
	{
		Sleep(10);
	}
}

bool KThread::StartThread()
{
	isThreadRunning=true;
	return CreateRFCThread(this);
}

KThread::~KThread()
{
}

// =========== KTimer.cpp ===========

/*
    RFC - KTimer.cpp
    Copyright (C) 2013 CrownSoft
  
    This software is provided 'as-is', without any express or implied
    warranty.  In no event will the authors be held liable for any damages
    arising from the use of this software.

    Permission is granted to anyone to use this software for any purpose,
    including commercial applications, and to alter it and redistribute it
    freely, subject to the following restrictions:

    1. The origin of this software must not be misrepresented; you must not
       claim that you wrote the original software. If you use this software
       in a product, an acknowledgment in the product documentation would be
       appreciated but is not required.
    2. Altered source versions must be plainly marked as such, and must not be
       misrepresented as being the original software.
    3. This notice may not be removed or altered from any source distribution.
      
*/


KTimer::KTimer()
{
	resolution=1000;
	started=false;
	listener=0;
	timerID=KPlatformUtil::GetInstance()->GenerateTimerID(this);
}

void KTimer::SetInterval(int resolution)
{
	this->resolution=resolution;
}

int KTimer::GetInterval()
{
	return resolution;
}

void KTimer::SetTimerWindow(KWindow *window)
{
	this->window=window;
}

void KTimer::SetTimerID(UINT timerID)
{
	this->timerID=timerID;
}

UINT KTimer::GetTimerID()
{
	return timerID;
}

void KTimer::StartTimer()
{
	HWND hwnd;

	if(started)
		return;

	if(window)
	{
		if(hwnd=window->GetHWND())
		{
			SetTimer(hwnd,timerID,resolution,0);
			started=true;
		}
	}
}

void KTimer::StopTimer()
{
	HWND hwnd;
	if(window)
	{
		if(hwnd=window->GetHWND())
		{
			if(started)
			{
				KillTimer(hwnd,timerID);
			}
			started=false;
		}
	}
}

bool KTimer::IsTimerRunning()
{
	return started;
}

void KTimer::OnTimer()
{
	if(listener)
	{
		listener->OnTimer(this);
	}
}

void KTimer::SetListener(KTimerListener *listener)
{
	this->listener=listener;
}

KTimer::~KTimer()
{
	if(started)
	{
		StopTimer();
	}
}

// =========== KTimerListener.cpp ===========

/*
    RFC - KTimerListener.cpp
    Copyright (C) 2013 CrownSoft
  
    This software is provided 'as-is', without any express or implied
    warranty.  In no event will the authors be held liable for any damages
    arising from the use of this software.

    Permission is granted to anyone to use this software for any purpose,
    including commercial applications, and to alter it and redistribute it
    freely, subject to the following restrictions:

    1. The origin of this software must not be misrepresented; you must not
       claim that you wrote the original software. If you use this software
       in a product, an acknowledgment in the product documentation would be
       appreciated but is not required.
    2. Altered source versions must be plainly marked as such, and must not be
       misrepresented as being the original software.
    3. This notice may not be removed or altered from any source distribution.
      
*/


KTimerListener::KTimerListener(){}

KTimerListener::~KTimerListener(){}

void KTimerListener::OnTimer(KTimer *timer){}



// =========== KString.cpp ===========

/*
RFC - KString.cpp
Copyright (C) 2013 CrownSoft

This software is provided 'as-is', without any express or implied
warranty.  In no event will the authors be held liable for any damages
arising from the use of this software.

Permission is granted to anyone to use this software for any purpose,
including commercial applications, and to alter it and redistribute it
freely, subject to the following restrictions:

1. The origin of this software must not be misrepresented; you must not
claim that you wrote the original software. If you use this software
in a product, an acknowledgment in the product documentation would be
appreciated but is not required.
2. Altered source versions must be plainly marked as such, and must not be
misrepresented as being the original software.
3. This notice may not be removed or altered from any source distribution.

*/



const KString operator+ (const char* const string1,const KString& string2)
{
	KString s(string1);
	s = s+string2;
	return s;
}

const KString operator+ (const wchar_t* const string1,const KString& string2)
{
	KString s(string1);
	s = s+string2;
	return s;
}

const KString operator+ (const KString& string1,const KString& string2)
{
	KString s(string1);
	s = s+string2;
	return s;
}

KString::KString()
{
	stringHolder=0;
}

KString::KString(const KString& other)
{
	if(other.stringHolder)
	{
		other.stringHolder->AddReference();
		stringHolder=other.stringHolder;
	}else
	{
		stringHolder=0;
	}
}

KString::KString(const char* const text,UINT codePage)
{

	if (text != 0)
	{
		int count = MultiByteToWideChar(codePage, 0, text, -1, 0,0); // get char count with null character
		if (count)
		{
			wchar_t *w_text = (wchar_t *)malloc(count*sizeof(wchar_t));
			if (MultiByteToWideChar(codePage, 0, text, -1, w_text,count))
			{
				count--; // ignore null character

				stringHolder=new KStringHolder();
				stringHolder->AddReference();

				stringHolder->w_text=w_text;
				stringHolder->count=count;
				return;
			}else
			{
				free(w_text);
			}
		}
	}

	stringHolder=0;		
}

KString::KString(const wchar_t* const text,UINT codePage)
{

	if (text != 0)
	{
		int count = (int)wcslen(text);
		if(count)
		{
			stringHolder=new KStringHolder();
			stringHolder->AddReference();

			stringHolder->w_text=(wchar_t*)malloc((count+1)*sizeof(wchar_t));
			wcscpy(stringHolder->w_text,text);
			stringHolder->count=count;
			return;
		}
	}

	stringHolder=0;	
}

KString::KString(const int value,const int radix)
{
	stringHolder=new KStringHolder();
	stringHolder->AddReference();

	stringHolder->w_text=(wchar_t *)malloc(33*sizeof(wchar_t)); // max 32 digits
	_itow(value,stringHolder->w_text,radix);

	stringHolder->count = (int)wcslen(stringHolder->w_text);
}

const KString& KString::operator= (const KString& other)
{

	if(stringHolder)
	{
		stringHolder->ReleaseReference();
	}

	if(other.stringHolder)
	{
		other.stringHolder->AddReference();
	}
	
	stringHolder=other.stringHolder;

	return *this;
}

const KString& KString::operator= (const wchar_t* const other)
{

	if(stringHolder)
	{
		stringHolder->ReleaseReference();
	}

	if (other != 0)
	{
		int count = (int)wcslen(other);
		if(count)
		{
			stringHolder=new KStringHolder();
			stringHolder->AddReference();

			stringHolder->w_text=(wchar_t*)malloc((count+1)*sizeof(wchar_t));
			wcscpy(stringHolder->w_text,other);
			stringHolder->count=count;
			return *this;
		}
	}

	stringHolder=0;	
	return *this;
}

const KString KString::operator+ (const KString& stringToAppend)
{
	return Append(stringToAppend);
}

const KString KString::operator+ (const wchar_t* const textToAppend)
{
	return Append(KString(textToAppend));
}

KString::operator const char*()
{
	if(stringHolder)
	{
		return stringHolder->GetAnsiVersion();
	}else
	{
		return 0;
	}
}

KString::operator const wchar_t*()
{
	if(stringHolder)
	{
		return stringHolder->w_text;
	}else
	{
		return 0;
	}
}

const char KString::operator[](const int index)
{
	if(stringHolder)
	{
		if((0<=index) && (index<=(stringHolder->count-1)))
		{
			return stringHolder->GetAnsiVersion()[index];
		}
	}
	return -1;
}

KString KString::Append(const KString &otherString)
{
	if( (otherString.stringHolder!=0) && (otherString.stringHolder->count!=0) )
	{
		KString result;
		result.stringHolder=new KStringHolder();
		result.stringHolder->AddReference();

		int length=otherString.stringHolder->count;
		int count=stringHolder?stringHolder->count:0;

		result.stringHolder->w_text=(wchar_t*)malloc((length+count+1)*sizeof(wchar_t));
		if(count) // this string is not empty!
		{
			wcscpy(result.stringHolder->w_text,stringHolder->w_text);
			wcsncat(result.stringHolder->w_text,otherString.stringHolder->w_text,length);
		}else
		{
			wcscpy(result.stringHolder->w_text,otherString.stringHolder->w_text);
		}

		result.stringHolder->count=length+count;
		return result;
	}else
	{
		return *this;
	}
}

KString KString::SubString(int start,int end)
{
	int count=stringHolder?stringHolder->count:0;

	if((0<=start) && (start<=(count-1)))
	{
		if((start<end) && (end<=(count-1)))
		{
			int size=(end-start)+1;
			wchar_t* buf=(wchar_t*)malloc((size+1)*sizeof(wchar_t));
			wcsncpy(buf,&stringHolder->w_text[start],size);
			buf[size]=0;

			KString result(buf);
			free(buf);
			return result;
		}
	}
	return KString();
}

bool KString::EqualsIgnoreCase(KString &otherString)
{
	if( (otherString.stringHolder!=0) && (otherString.stringHolder->count!=0) )
	{
		if( (stringHolder!=0) && (stringHolder->count!=0) )
		{
			if(wcscmp(stringHolder->w_text,otherString.stringHolder->w_text)==0)
			{
				return true;
			}
		}
	}
	return false;
}

bool KString::StartsWithChar(wchar_t character)
{
	if( (stringHolder!=0) && (stringHolder->count!=0) )
	{
		if(stringHolder->w_text[0]==character)
		{
			return true;
		}
	}
	return false;
}

bool KString::StartsWithChar(char character)
{
	if( (stringHolder!=0) && (stringHolder->count!=0) )
	{
		if(stringHolder->GetAnsiVersion()[0]==character)
		{
			return true;
		}
	}
	return false;
}

bool KString::EndsWithChar(wchar_t character)
{
	if( (stringHolder!=0) && (stringHolder->count!=0) )
	{
		if(stringHolder->w_text[stringHolder->count-1]==character)
		{
			return true;
		}
	}
	return false;
}

bool KString::EndsWithChar(char character)
{
	if( (stringHolder!=0) && (stringHolder->count!=0) )
	{
		if(stringHolder->GetAnsiVersion()[stringHolder->count-1]==character)
		{
			return true;
		}
	}
	return false;
}

bool KString::IsQuotedString()
{
	if( (stringHolder!=0) && (stringHolder->count>1) )
	{
		if(StartsWithChar(L'\"') && EndsWithChar(L'\"'))
		{
			return true;
		}
	}
	return false;
}

wchar_t KString::GetCharAt(int index)
{
	int count=stringHolder?stringHolder->count:0;

	if((0<=index) && (index<=(count-1)))
		return stringHolder->w_text[index];
	return -1;
}

int KString::GetLength()
{
	return stringHolder?stringHolder->count:0;
}

bool KString::IsEmpty()
{
	if(stringHolder?stringHolder->count:0)
	{
		return false;
	}
	return true;
}

int KString::GetIntValue()
{
	if(IsEmpty())
	{
		return 0;
	}
	return _wtoi(stringHolder->w_text);
}

KString::~KString()
{
	if(stringHolder)
	{
		stringHolder->ReleaseReference();
	}
}


// =========== KStringHolder.cpp ===========

/*
    RFC - KStringHolder.cpp
    Copyright (C) 2013 CrownSoft
  
    This software is provided 'as-is', without any express or implied
    warranty.  In no event will the authors be held liable for any damages
    arising from the use of this software.

    Permission is granted to anyone to use this software for any purpose,
    including commercial applications, and to alter it and redistribute it
    freely, subject to the following restrictions:

    1. The origin of this software must not be misrepresented; you must not
       claim that you wrote the original software. If you use this software
       in a product, an acknowledgment in the product documentation would be
       appreciated but is not required.
    2. Altered source versions must be plainly marked as such, and must not be
       misrepresented as being the original software.
    3. This notice may not be removed or altered from any source distribution.
      
*/



KStringHolder::KStringHolder()
{
	refCount=0;
	a_text=0;
	w_text=0;
	count=0;
	InitializeCriticalSection(&cs_a_text);
}

KStringHolder::~KStringHolder()
{
	DeleteCriticalSection(&cs_a_text);
}

void KStringHolder::AddReference()
{
	InterlockedIncrement(&refCount);
}

void KStringHolder::ReleaseReference()
{
	LONG res=InterlockedDecrement(&refCount);
	if(res==0)
	{
		if(a_text)
		{
			free(a_text);
		}
		if(w_text)
		{
			free(w_text);
		}
		delete this;
	}
}

const char* KStringHolder::GetAnsiVersion()
{
	EnterCriticalSection(&cs_a_text);

	if(a_text)
	{
		LeaveCriticalSection(&cs_a_text);
		return a_text;
	}else
	{
		int length = WideCharToMultiByte(CP_ACP,0, w_text, -1, 0,0,0,0);
		if (length)
		{
			a_text = (char*)malloc(length);
			if (WideCharToMultiByte(CP_ACP,0, w_text, -1, a_text,length,0,0))
			{
				LeaveCriticalSection(&cs_a_text);
				return a_text;
			}
			free(a_text);
			a_text=0;
		}

		LeaveCriticalSection(&cs_a_text);
		return 0; // conversion error
	}
}

// =========== KButton.cpp ===========

/*
    RFC - KButton.cpp
    Copyright (C) 2013 CrownSoft
  
    This software is provided 'as-is', without any express or implied
    warranty.  In no event will the authors be held liable for any damages
    arising from the use of this software.

    Permission is granted to anyone to use this software for any purpose,
    including commercial applications, and to alter it and redistribute it
    freely, subject to the following restrictions:

    1. The origin of this software must not be misrepresented; you must not
       claim that you wrote the original software. If you use this software
       in a product, an acknowledgment in the product documentation would be
       appreciated but is not required.
    2. Altered source versions must be plainly marked as such, and must not be
       misrepresented as being the original software.
    3. This notice may not be removed or altered from any source distribution.
      
*/


KButton::KButton()
{
	listener=0;

	compClassName=KString(L"BUTTON");

	SetText(KString(L"Button"));
	SetSize(100,30);
	SetPosition(0,0);
	SetStyle(WS_CHILD|WS_CLIPSIBLINGS|BS_NOTIFY|WS_TABSTOP);
	SetExStyle(WS_EX_WINDOWEDGE);
}

void KButton::SetListener(KButtonListener *listener)
{
	this->listener=listener;
}

KButtonListener* KButton::GetListener()
{
	return listener;
}

void KButton::OnPress()
{
	if(listener)
		listener->OnButtonPress(this);
}

bool KButton::CreateComponent()
{
	if(!compParentHWND) // user must specify parent handle!
		return false;

	CreateRFCComponent(this); // we dont need to register BUTTON class!

	if(compHWND)
	{
		SendMessageW(compHWND,WM_SETFONT,(WPARAM)compFont->GetFontHandle(),MAKELPARAM(true, 0)); // set default font!

		EnableWindow(compHWND,compEnabled);

		if(this->IsVisible())
			this->SetVisible(true);
		return true;
	}
	return false;
}

KButton::~KButton()
{
}

// =========== KButtonListener.cpp ===========

/*
    RFC - KButtonListener.cpp
    Copyright (C) 2013 CrownSoft
  
    This software is provided 'as-is', without any express or implied
    warranty.  In no event will the authors be held liable for any damages
    arising from the use of this software.

    Permission is granted to anyone to use this software for any purpose,
    including commercial applications, and to alter it and redistribute it
    freely, subject to the following restrictions:

    1. The origin of this software must not be misrepresented; you must not
       claim that you wrote the original software. If you use this software
       in a product, an acknowledgment in the product documentation would be
       appreciated but is not required.
    2. Altered source versions must be plainly marked as such, and must not be
       misrepresented as being the original software.
    3. This notice may not be removed or altered from any source distribution.
      
*/


KButtonListener::KButtonListener(){}

KButtonListener::~KButtonListener(){}

void KButtonListener::OnButtonPress(KButton *button){}

// =========== KCheckBox.cpp ===========

/*
    RFC - KCheckBox.cpp
    Copyright (C) 2013 CrownSoft
  
    This software is provided 'as-is', without any express or implied
    warranty.  In no event will the authors be held liable for any damages
    arising from the use of this software.

    Permission is granted to anyone to use this software for any purpose,
    including commercial applications, and to alter it and redistribute it
    freely, subject to the following restrictions:

    1. The origin of this software must not be misrepresented; you must not
       claim that you wrote the original software. If you use this software
       in a product, an acknowledgment in the product documentation would be
       appreciated but is not required.
    2. Altered source versions must be plainly marked as such, and must not be
       misrepresented as being the original software.
    3. This notice may not be removed or altered from any source distribution.
      
*/


KCheckBox::KCheckBox()
{
	checked=false;

	SetText(KString(L"CheckBox"));
	SetStyle(WS_CHILD|WS_CLIPSIBLINGS|BS_AUTOCHECKBOX|BS_NOTIFY|WS_TABSTOP);
}

bool KCheckBox::CreateComponent()
{
	if(!compParentHWND) // user must specify parent handle!
		return false;

	CreateRFCComponent(this); // we dont need to register BUTTON class!

	if(compHWND)
	{
		SendMessageW(compHWND,WM_SETFONT,(WPARAM)compFont->GetFontHandle(),MAKELPARAM(true, 0)); // set default font!
		SendMessageW(compHWND,BM_SETCHECK,checked,0);

		EnableWindow(compHWND,compEnabled);

		if(this->IsVisible())
			this->SetVisible(true);
		return true;
	}
	return false;
}

void KCheckBox::OnPress()
{
	if(SendMessageW(compHWND,BM_GETCHECK,0,0)==BST_CHECKED)
		checked=true;
	else
		checked=false;

	if(listener)
		listener->OnButtonPress(this);
}

bool KCheckBox::IsChecked()
{
	return checked;
}

void KCheckBox::SetCheckedState(bool state)
{
	checked=state;

	if(compHWND)
		SendMessageW(compHWND,BM_SETCHECK,checked,0);
}

KCheckBox::~KCheckBox()
{
}

// =========== KComboBox.cpp ===========

/*
    RFC - KComboBox.cpp
    Copyright (C) 2013 CrownSoft
  
    This software is provided 'as-is', without any express or implied
    warranty.  In no event will the authors be held liable for any damages
    arising from the use of this software.

    Permission is granted to anyone to use this software for any purpose,
    including commercial applications, and to alter it and redistribute it
    freely, subject to the following restrictions:

    1. The origin of this software must not be misrepresented; you must not
       claim that you wrote the original software. If you use this software
       in a product, an acknowledgment in the product documentation would be
       appreciated but is not required.
    2. Altered source versions must be plainly marked as such, and must not be
       misrepresented as being the original software.
    3. This notice may not be removed or altered from any source distribution.
      
*/



KComboBox::KComboBox(bool sort)
{
	listener=0;
	selectedItemIndex=-1;

	compClassName=KString(L"COMBOBOX");

	SetSize(100,100);
	SetPosition(0,0);

	SetStyle(WS_VSCROLL|CBS_DROPDOWNLIST|WS_CHILD|WS_CLIPSIBLINGS|WS_TABSTOP);

	if(sort)
		SetStyle(compDwStyle|CBS_SORT);

	SetExStyle(WS_EX_CLIENTEDGE|WS_EX_WINDOWEDGE);

	stringList=new KPointerList<KString*>;
}

void KComboBox::AddItem(KString &text)
{
	KString *str=new KString(text);
	stringList->AddPointer(str);
	if(compHWND)
		SendMessageW(compHWND,CB_ADDSTRING,0,(LPARAM)(const wchar_t*)*str);
}

void KComboBox::RemoveItem(int index)
{
	stringList->RemovePointer(index);

	if(compHWND)	 
		SendMessageW(compHWND,CB_DELETESTRING,index,0);
}

void KComboBox::RemoveItem(KString &text)
{
	int itemIndex=GetItemIndex(text);
	if(itemIndex>-1)
		RemoveItem(itemIndex);
}

int KComboBox::GetItemIndex(KString &text)
{
	int listSize=stringList->GetSize();
	if(listSize)
	{
		for(int i=0;i<listSize;i++)
		{
			if(stringList->GetPointer(i)->EqualsIgnoreCase(text))
				return i;
		}
	}
	return -1;
}

int KComboBox::GetItemCount()
{
	return stringList->GetSize();
}

int KComboBox::GetSelectedItemIndex()
{
	if(compHWND)
	{	 
		int index=(int)SendMessageW(compHWND,CB_GETCURSEL,0,0);
		if(index!=CB_ERR)
			return index;
		return -1;
	}else
	{
		return -1;
	}	
}

KString KComboBox::GetSelectedItem()
{
	int itemIndex=GetSelectedItemIndex();
	if(itemIndex>-1)
		return *stringList->GetPointer(itemIndex);
	return KString();
}

void KComboBox::ClearList()
{
	stringList->DeleteAll();
	if(compHWND)
	{
		SendMessageW(compHWND,CB_RESETCONTENT,0,0);
	}
}

void KComboBox::SelectItem(int index)
{
	selectedItemIndex=index;
	if(compHWND)
	{
		SendMessageW(compHWND,CB_SETCURSEL,index,0);
	}
}

bool KComboBox::CreateComponent()
{
	if(!compParentHWND) // user must specify parent handle!
		return false;

	CreateRFCComponent(this); // we dont need to register COMBOBOX class!

	if(compHWND)
	{
		SendMessageW(compHWND,WM_SETFONT,(WPARAM)compFont->GetFontHandle(),MAKELPARAM(true, 0)); // set default font!

		EnableWindow(compHWND,compEnabled);

		int listSize=stringList->GetSize();
		if(listSize)
		{
			for(int i=0;i<listSize;i++)
				SendMessageW(compHWND,CB_ADDSTRING,0,(LPARAM)(const wchar_t*)*stringList->GetPointer(i));
		}

		if(selectedItemIndex>-1)
			SendMessageW(compHWND,CB_SETCURSEL,selectedItemIndex,0);


		if(this->IsVisible())
			this->SetVisible(true);
		return true;
	}

	return false;
}

void KComboBox::SetListener(KComboBoxListener *listener)
{
	this->listener=listener;
}

void KComboBox::OnItemSelect()
{
	if(listener)
		listener->OnComboBoxItemSelect(this);
}

KComboBox::~KComboBox()
{
	stringList->DeleteAll();
	delete stringList;
}



// =========== KComboBoxListener.cpp ===========

/*
    RFC - KComboBoxListener.h
    Copyright (C) 2013 CrownSoft
  
    This software is provided 'as-is', without any express or implied
    warranty.  In no event will the authors be held liable for any damages
    arising from the use of this software.

    Permission is granted to anyone to use this software for any purpose,
    including commercial applications, and to alter it and redistribute it
    freely, subject to the following restrictions:

    1. The origin of this software must not be misrepresented; you must not
       claim that you wrote the original software. If you use this software
       in a product, an acknowledgment in the product documentation would be
       appreciated but is not required.
    2. Altered source versions must be plainly marked as such, and must not be
       misrepresented as being the original software.
    3. This notice may not be removed or altered from any source distribution.
      
*/


KComboBoxListener::KComboBoxListener(){}

KComboBoxListener::~KComboBoxListener(){}

void KComboBoxListener::OnComboBoxItemSelect(KComboBox *comboBox){}

// =========== KCommonDialogBox.cpp ===========

/*
    RFC - KCommonDialogBox.cpp
    Copyright (C) 2013 CrownSoft
  
    This software is provided 'as-is', without any express or implied
    warranty.  In no event will the authors be held liable for any damages
    arising from the use of this software.

    Permission is granted to anyone to use this software for any purpose,
    including commercial applications, and to alter it and redistribute it
    freely, subject to the following restrictions:

    1. The origin of this software must not be misrepresented; you must not
       claim that you wrote the original software. If you use this software
       in a product, an acknowledgment in the product documentation would be
       appreciated but is not required.
    2. Altered source versions must be plainly marked as such, and must not be
       misrepresented as being the original software.
    3. This notice may not be removed or altered from any source distribution.
      
*/


bool KCommonDialogBox::ShowOpenFileDialog(KWindow *window,KString &title,wchar_t* filter,KString *fileName)
{
	OPENFILENAMEW ofn;
	static wchar_t buff[MAX_PATH];

	ZeroMemory(&ofn, sizeof(OPENFILENAMEW));

	ofn.lStructSize = sizeof(OPENFILENAMEW);
	ofn.hwndOwner = window->GetHWND();
	ofn.lpstrFilter = filter;
	ofn.lpstrFile = buff;
	ofn.nMaxFile = MAX_PATH;
	ofn.Flags =  OFN_FILEMUSTEXIST|OFN_HIDEREADONLY;
	ofn.lpstrTitle = (const wchar_t*)title;

	if(GetOpenFileNameW(&ofn))
	{
		*fileName=KString(buff);
		return true;
	}else
	{
		return false;
	}
}

bool KCommonDialogBox::ShowSaveFileDialog(KWindow *window,KString &title,wchar_t* filter,KString *fileName)
{
	OPENFILENAMEW ofn;
	static wchar_t buff[MAX_PATH];

	ZeroMemory(&ofn, sizeof(OPENFILENAMEW));

	ofn.lStructSize = sizeof(OPENFILENAMEW);
	ofn.hwndOwner = window->GetHWND();
	ofn.lpstrFilter = filter;
	ofn.lpstrFile = buff;
	ofn.nMaxFile = MAX_PATH;
	ofn.Flags =  OFN_FILEMUSTEXIST|OFN_HIDEREADONLY;
	ofn.lpstrTitle = (const wchar_t*)title;

	if(GetSaveFileNameW(&ofn))
	{
		*fileName=KString(buff);
		return true;
	}else
	{
		return false;
	}
}

// =========== KComponent.cpp ===========

/*
    RFC - KComponent.cpp
    Copyright (C) 2013 CrownSoft
  
    This software is provided 'as-is', without any express or implied
    warranty.  In no event will the authors be held liable for any damages
    arising from the use of this software.

    Permission is granted to anyone to use this software for any purpose,
    including commercial applications, and to alter it and redistribute it
    freely, subject to the following restrictions:

    1. The origin of this software must not be misrepresented; you must not
       claim that you wrote the original software. If you use this software
       in a product, an acknowledgment in the product documentation would be
       appreciated but is not required.
    2. Altered source versions must be plainly marked as such, and must not be
       misrepresented as being the original software.
    3. This notice may not be removed or altered from any source distribution.
      
*/




KComponent::KComponent()
{
	isRegistered=false;

	compClassName=KPlatformUtil::GetInstance()->GenerateClassName();

	compHWND=0;
	compParentHWND=0;
	compText=KString();
	compDwStyle=0;
	compDwExStyle=0;
	cursor=0;
	compX=CW_USEDEFAULT;
	compY=CW_USEDEFAULT;
	compWidth=CW_USEDEFAULT;
	compHeight=CW_USEDEFAULT;
	compVisible=true;
	compEnabled=true;

	wc.cbSize=sizeof(WNDCLASSEX);
	wc.hCursor=LoadCursor(NULL,IDC_ARROW);
	wc.hIcon=0;
	wc.lpszMenuName=0;
	wc.hbrBackground=(HBRUSH)GetSysColorBrush(COLOR_BTNFACE);
	wc.cbClsExtra=0;
	wc.cbWndExtra=0;
	wc.hIconSm=0;
	wc.style=0;
	wc.hInstance=KPlatformUtil::GetInstance()->GetAppInstance();
	wc.lpszClassName=(const wchar_t*)compClassName;

	wc.lpfnWndProc=GlobalWnd_Proc;

	compFont=KFont::GetDefaultFont();
}

void KComponent::OnHotPlug()
{

	RECT rect;
	GetWindowRect(compHWND,&rect);
	compWidth=rect.right-rect.left;
	compHeight=rect.bottom-rect.top;
	compX=rect.left;
	compY=rect.top;

	compVisible=IsWindowVisible(compHWND)?true:false;
	compEnabled=IsWindowEnabled(compHWND)?true:false;

	compDwStyle=GetWindowLong(compHWND,GWL_STYLE);
	compDwExStyle=GetWindowLong(compHWND,GWL_EXSTYLE);

	compParentHWND=GetParent(compHWND);

	wchar_t buff[255];
	GetWindowText(compHWND,buff,255);
	compText=buff;

	GetClassName(compHWND,buff,255);
	compClassName=buff;

	GetClassInfoEx(KPlatformUtil::GetInstance()->GetAppInstance(),compClassName,&wc);

}

void KComponent::HotPlugInto(HWND component)
{
	static const wchar_t* RFCPropText_Object=L"RFC";
	static const wchar_t* RFCPropText_OldProc=L"RFCOldProc";

	compHWND=component;
	SetPropW(compHWND,RFCPropText_Object,(HANDLE)this);
	FARPROC lpfnOldWndProc=(FARPROC)GetWindowLong(compHWND,GWL_WNDPROC);
	SetPropW(compHWND,RFCPropText_OldProc,(HANDLE)lpfnOldWndProc);

	SetWindowLongW(compHWND,GWL_WNDPROC,(LONG)GlobalWnd_Proc); // subclassing...

	this->OnHotPlug();
}

void KComponent::SetMouseCursor(KCursor *cursor)
{
	this->cursor=cursor;
	if(compHWND)
		SetClassLongW(compHWND,GCL_HCURSOR,(LONG)cursor->GetHandle());
}

KString KComponent::GetComponentClassName()
{
	return compClassName;
}

bool KComponent::CreateComponent()
{
	if(!RegisterClassExW(&wc))
		return false;

	isRegistered=true;

	CreateRFCComponent(this);

	if(compHWND)
	{
		EnableWindow(compHWND,compEnabled);

		if(this->IsVisible())
			this->SetVisible(true);

		if(cursor)
			SetClassLongW(compHWND,GCL_HCURSOR,(LONG)cursor->GetHandle());

		return true;
	}
	return false;
}

LRESULT KComponent::WindowProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	static const wchar_t* RFCPropText_OldProc=L"RFCOldProc";

	FARPROC lpfnOldWndProc=(FARPROC)GetPropW(hwnd, RFCPropText_OldProc);
	if(lpfnOldWndProc)
		if((void*)lpfnOldWndProc!=(void*)GlobalWnd_Proc) // it's subclassed control or dialog! RFCOldProc of subclassed dialog is not GlobalDlg_Proc function.
			return CallWindowProcW((WNDPROC)lpfnOldWndProc, hwnd, msg, wParam,lParam);
	return DefWindowProcW(hwnd,msg,wParam,lParam);
}

void KComponent::SetFont(KFont *compFont)
{
	this->compFont=compFont;
	if(compHWND)
		SendMessageW(compHWND,WM_SETFONT,(WPARAM)compFont->GetFontHandle(),MAKELPARAM(true, 0));
}

KFont* KComponent::GetFont()
{
	return compFont;
}

KString KComponent::GetText()
{
	return compText;
}

void KComponent::SetText(KString &compText)
{
	this->compText=compText;
	if(compHWND)
		SetWindowTextW(compHWND,(const wchar_t*)compText);
}

void KComponent::SetHWND(HWND compHWND)
{
	this->compHWND=compHWND;
}

HWND KComponent::GetHWND()
{
	return compHWND;
}

void KComponent::SetParentHWND(HWND compParentHWND)
{
	this->compParentHWND=compParentHWND;
	if(compHWND)
		SetParent(compHWND,compParentHWND);
}

HWND KComponent::GetParentHWND()
{
	return compParentHWND;
}

DWORD KComponent::GetStyle()
{
	return compDwStyle;
}

void KComponent::SetStyle(DWORD compStyle)
{
	this->compDwStyle=compStyle;
	if(compHWND)
		SetWindowLongW(compHWND,GWL_STYLE,compStyle);
}

DWORD KComponent::GetExStyle()
{
	return compDwExStyle;
}

void KComponent::SetExStyle(DWORD compDwExStyle)
{
	this->compDwExStyle=compDwExStyle;
	if(compHWND)
		SetWindowLongW(compHWND,GWL_EXSTYLE,compDwExStyle);
}

int KComponent::GetX()
{
	return compX; 
}

int KComponent::GetY()
{
	return compY;
}

int KComponent::GetWidth()
{
	return compWidth;
}

int KComponent::GetHeight()
{
	return compHeight;
}

void KComponent::SetSize(int compWidth,int compHeight)
{
	this->compWidth=compWidth;
	this->compHeight=compHeight;

	if(compHWND)
		SetWindowPos(compHWND,0,0,0,compWidth,compHeight,SWP_NOMOVE|SWP_NOREPOSITION);
}

void KComponent::SetPosition(int compX,int compY)
{
	this->compX=compX;
	this->compY=compY;

	if(compHWND)
		SetWindowPos(compHWND,0,compX,compY,0,0,SWP_NOSIZE|SWP_NOREPOSITION);
}

void KComponent::SetVisible(bool state)
{
	this->compVisible=state;
	if(compHWND)
		ShowWindow(compHWND,state ? SW_SHOW:SW_HIDE);
}

bool KComponent::IsVisible()
{
	return compHWND ? this->compVisible : false;
}

bool KComponent::IsEnabled()
{
	return compEnabled;
}

void KComponent::SetEnabled(bool state)
{
	compEnabled=state;

	if(compHWND)
		EnableWindow(compHWND,compEnabled);
}

void KComponent::BringToFront()
{
	if(compHWND)
		BringWindowToTop(compHWND);
}

void KComponent::SetKeyboardFocus()
{
	if(compHWND)
		SetFocus(compHWND);
}

void KComponent::Repaint()
{
	if(compHWND)
		InvalidateRect(compHWND, NULL, TRUE);
}

KComponent::~KComponent()
{
	if(isRegistered)
		UnregisterClassW((const wchar_t*)compClassName,KPlatformUtil::GetInstance()->GetAppInstance());
}

// =========== KGroupBox.cpp ===========

/*
    RFC - KGroupBox.h
    Copyright (C) 2013 CrownSoft
  
    This software is provided 'as-is', without any express or implied
    warranty.  In no event will the authors be held liable for any damages
    arising from the use of this software.

    Permission is granted to anyone to use this software for any purpose,
    including commercial applications, and to alter it and redistribute it
    freely, subject to the following restrictions:

    1. The origin of this software must not be misrepresented; you must not
       claim that you wrote the original software. If you use this software
       in a product, an acknowledgment in the product documentation would be
       appreciated but is not required.
    2. Altered source versions must be plainly marked as such, and must not be
       misrepresented as being the original software.
    3. This notice may not be removed or altered from any source distribution.
      
*/


KGroupBox::KGroupBox()
{
	SetText(KString(L"GroupBox"));
	SetSize(100,100);
	SetStyle(WS_CHILD|WS_CLIPSIBLINGS|BS_GROUPBOX);
}

KGroupBox::~KGroupBox()
{
}

// =========== KLabel.cpp ===========

/*
    RFC - KLabel.cpp
    Copyright (C) 2013 CrownSoft
  
    This software is provided 'as-is', without any express or implied
    warranty.  In no event will the authors be held liable for any damages
    arising from the use of this software.

    Permission is granted to anyone to use this software for any purpose,
    including commercial applications, and to alter it and redistribute it
    freely, subject to the following restrictions:

    1. The origin of this software must not be misrepresented; you must not
       claim that you wrote the original software. If you use this software
       in a product, an acknowledgment in the product documentation would be
       appreciated but is not required.
    2. Altered source versions must be plainly marked as such, and must not be
       misrepresented as being the original software.
    3. This notice may not be removed or altered from any source distribution.
      
*/


KLabel::KLabel()
{
	compClassName=KString(L"STATIC");

	SetText(KString(L"Label"));
	SetSize(100,25);
	SetPosition(0,0);
	SetStyle(WS_CHILD|WS_CLIPSIBLINGS|BS_NOTIFY);
	SetExStyle(WS_EX_WINDOWEDGE);
}

bool KLabel::CreateComponent()
{
	if(!compParentHWND) // user must specify parent handle!
		return false;

	CreateRFCComponent(this); // we dont need to register Label class!

	if(compHWND)
	{
		SendMessageW(compHWND,WM_SETFONT,(WPARAM)compFont->GetFontHandle(),MAKELPARAM(true, 0)); // set default font!

		EnableWindow(compHWND,compEnabled);

		if(this->IsVisible())
			this->SetVisible(true);
		return true;
	}
	return false;
}

KLabel::~KLabel()
{
}

// =========== KListBox.cpp ===========

/*
    RFC - KListBox.cpp
    Copyright (C) 2013 CrownSoft
  
    This software is provided 'as-is', without any express or implied
    warranty.  In no event will the authors be held liable for any damages
    arising from the use of this software.

    Permission is granted to anyone to use this software for any purpose,
    including commercial applications, and to alter it and redistribute it
    freely, subject to the following restrictions:

    1. The origin of this software must not be misrepresented; you must not
       claim that you wrote the original software. If you use this software
       in a product, an acknowledgment in the product documentation would be
       appreciated but is not required.
    2. Altered source versions must be plainly marked as such, and must not be
       misrepresented as being the original software.
    3. This notice may not be removed or altered from any source distribution.
      
*/


KListBox::KListBox(bool multipleSelection,bool sort,bool vscroll)
{
	this->multipleSelection=multipleSelection;
	listener=0;

	selectedItemIndex=-1;
	selectedItemEnd=-1;

	compClassName=KString(L"LISTBOX");

	SetSize(100,100);
	SetPosition(0,0);

	SetStyle(LBS_NOTIFY|WS_CHILD|WS_CLIPSIBLINGS|WS_TABSTOP);

	if(multipleSelection)
		SetStyle(compDwStyle|LBS_MULTIPLESEL);
	if(sort)
		SetStyle(compDwStyle|LBS_SORT);
	if(vscroll)
		SetStyle(compDwStyle|WS_VSCROLL);

	SetExStyle(WS_EX_CLIENTEDGE|WS_EX_WINDOWEDGE);

	stringList=new KPointerList<KString*>;
}

void KListBox::SetListener(KListBoxListener *listener)
{
	this->listener=listener;
}

void KListBox::AddItem(KString &text)
{
	KString *str=new KString(text);
	stringList->AddPointer(str);
	if(compHWND)
		SendMessageW(compHWND,LB_ADDSTRING,0,(LPARAM)(const wchar_t*)*str);
}

void KListBox::RemoveItem(int index)
{
	stringList->RemovePointer(index);

	if(compHWND)	 
		SendMessageW(compHWND,LB_DELETESTRING,index,0);
}

void KListBox::RemoveItem(KString &text)
{
	int itemIndex=GetItemIndex(text);
	if(itemIndex>-1)
		RemoveItem(itemIndex);
}

int KListBox::GetItemIndex(KString &text)
{
	int listSize=stringList->GetSize();
	if(listSize)
	{
		for(int i=0;i<listSize;i++)
		{
			if(stringList->GetPointer(i)->EqualsIgnoreCase(text))
				return i;
		}
	}
	return -1;
}

int KListBox::GetItemCount()
{
	return stringList->GetSize();
}

int KListBox::GetSelectedItemIndex()
{
	if(compHWND)
	{	 
		int index=(int)SendMessageW(compHWND,LB_GETCURSEL,0,0);
		if(index!=LB_ERR)
			return index;
		return -1;
	}else
	{
		return -1;
	}	
}

KString KListBox::GetSelectedItem()
{
	int itemIndex=GetSelectedItemIndex();
	if(itemIndex>-1)
		return *stringList->GetPointer(itemIndex);
	return KString();
}

int KListBox::GetSelectedItems(int* itemArray,int itemCountInArray)
{
	if(compHWND)
	{	 
		int items=(int)SendMessageW(compHWND,LB_GETSELITEMS,itemCountInArray,(LPARAM)itemArray);
		if(items!=LB_ERR)
			return items;
		return -1;
	}else
	{
		return -1;
	}
}

void KListBox::ClearList()
{
	stringList->DeleteAll();
	if(compHWND)
	{
		SendMessageW(compHWND,LB_RESETCONTENT,0,0);
	}
}

void KListBox::SelectItem(int index)
{
	selectedItemIndex=index;
	if(compHWND)
	{
		SendMessageW(compHWND,LB_SETCURSEL,index,0);
	}
}

void KListBox::SelectItems(int start,int end)
{
	if(multipleSelection)
	{
		selectedItemIndex=start;
		selectedItemEnd=end;

		if(compHWND)
			SendMessageW(compHWND,LB_SELITEMRANGE,TRUE,MAKELPARAM(start,end));
	}
}

bool KListBox::CreateComponent()
{
	if(!compParentHWND) // user must specify parent handle!
		return false;

	CreateRFCComponent(this); // we dont need to register LISTBOX class!

	if(compHWND)
	{
		SendMessageW(compHWND,WM_SETFONT,(WPARAM)compFont->GetFontHandle(),MAKELPARAM(true, 0)); // set default font!

		EnableWindow(compHWND,compEnabled);

		int listSize=stringList->GetSize();
		if(listSize)
		{
			for(int i=0;i<listSize;i++)
				SendMessageW(compHWND,LB_ADDSTRING,0,(LPARAM)(const wchar_t*)*stringList->GetPointer(i));
		}

		if(!multipleSelection) // single selction!
		{
			if(selectedItemIndex>-1)
				SendMessageW(compHWND,LB_SETCURSEL,selectedItemIndex,0);
		}else
		{
			if(selectedItemIndex>-1)
				SendMessageW(compHWND,LB_SELITEMRANGE,TRUE,MAKELPARAM(selectedItemIndex,selectedItemEnd));
		}

		if(this->IsVisible())
			this->SetVisible(true);
		return true;
	}

	return false;
}

void KListBox::OnItemSelect()
{
	if(listener)
		listener->OnListBoxItemSelect(this);
}

KListBox::~KListBox()
{
	stringList->DeleteAll();
	delete stringList;
}

// =========== KListBoxListener.cpp ===========

/*
    RFC - KListBoxListener.cpp
    Copyright (C) 2013 CrownSoft
  
    This software is provided 'as-is', without any express or implied
    warranty.  In no event will the authors be held liable for any damages
    arising from the use of this software.

    Permission is granted to anyone to use this software for any purpose,
    including commercial applications, and to alter it and redistribute it
    freely, subject to the following restrictions:

    1. The origin of this software must not be misrepresented; you must not
       claim that you wrote the original software. If you use this software
       in a product, an acknowledgment in the product documentation would be
       appreciated but is not required.
    2. Altered source versions must be plainly marked as such, and must not be
       misrepresented as being the original software.
    3. This notice may not be removed or altered from any source distribution.
      
*/


KListBoxListener::KListBoxListener(){}
KListBoxListener::~KListBoxListener(){}

void KListBoxListener::OnListBoxItemSelect(KListBox *listBox){}

// =========== KMenu.cpp ===========

/*
    RFC - KMenu.cpp
    Copyright (C) 2013 CrownSoft
  
    This software is provided 'as-is', without any express or implied
    warranty.  In no event will the authors be held liable for any damages
    arising from the use of this software.

    Permission is granted to anyone to use this software for any purpose,
    including commercial applications, and to alter it and redistribute it
    freely, subject to the following restrictions:

    1. The origin of this software must not be misrepresented; you must not
       claim that you wrote the original software. If you use this software
       in a product, an acknowledgment in the product documentation would be
       appreciated but is not required.
    2. Altered source versions must be plainly marked as such, and must not be
       misrepresented as being the original software.
    3. This notice may not be removed or altered from any source distribution.
      
*/


#ifdef _MSC_VER
#pragma warning( disable : 4311 ) // pointer truncation from HMENU to UINT warning!
#endif

KMenu::KMenu()
{
	hMenu=CreatePopupMenu();
}

void KMenu::AddMenuItem(KMenuItem *menuItem)
{
	menuItem->AddToMenu(hMenu);
}

void KMenu::AddSubMenu(KString &text,KMenu *menu)
{
	InsertMenuW(hMenu,0xFFFFFFFF,MF_BYPOSITION|MF_POPUP|MF_STRING,(UINT)menu->GetMenuHandle(),(const wchar_t*)text);
}

void KMenu::AddSeperator()
{
	MENUITEMINFOW mii;
	ZeroMemory(&mii, sizeof(mii));

	mii.cbSize=sizeof(MENUITEMINFOW);
	mii.fMask=MIIM_TYPE;
	mii.fType=MFT_SEPARATOR;

	InsertMenuItemW(hMenu,0xFFFFFFFF,FALSE,&mii);
}

HMENU KMenu::GetMenuHandle()
{
	return hMenu;
}

void KMenu::PopUpMenu(KWindow *window)
{
	if(window)
	{
		POINT p;
		GetCursorPos(&p);
		TrackPopupMenu(hMenu, TPM_LEFTBUTTON, p.x, p.y, 0, window->GetHWND(), NULL);
	}
}

KMenu::~KMenu()
{
	DestroyMenu(hMenu);
}

// =========== KMenuBar.cpp ===========

/*
    RFC - KMenuBar.cpp
    Copyright (C) 2013 CrownSoft
  
    This software is provided 'as-is', without any express or implied
    warranty.  In no event will the authors be held liable for any damages
    arising from the use of this software.

    Permission is granted to anyone to use this software for any purpose,
    including commercial applications, and to alter it and redistribute it
    freely, subject to the following restrictions:

    1. The origin of this software must not be misrepresented; you must not
       claim that you wrote the original software. If you use this software
       in a product, an acknowledgment in the product documentation would be
       appreciated but is not required.
    2. Altered source versions must be plainly marked as such, and must not be
       misrepresented as being the original software.
    3. This notice may not be removed or altered from any source distribution.
      
*/


#ifdef _MSC_VER
#pragma warning( disable : 4311 ) // pointer truncation from HMENU to UINT warning!
#endif

KMenuBar::KMenuBar()
{
	hMenu=CreateMenu();
}

void KMenuBar::AddMenu(KString &text,KMenu *menu)
{
	InsertMenuW(hMenu,0xFFFFFFFF,MF_BYPOSITION|MF_POPUP|MF_STRING,(UINT)menu->GetMenuHandle(),(const wchar_t*)text);
}

void KMenuBar::AddToWindow(KWindow *window)
{
	HWND hwnd=window->GetHWND();
	if(hwnd)
		SetMenu(hwnd,hMenu);
}

KMenuBar::~KMenuBar()
{
	DestroyMenu(hMenu);
}

// =========== KMenuItem.cpp ===========

/*
    RFC - KMenuItem.cpp
    Copyright (C) 2013 CrownSoft
  
    This software is provided 'as-is', without any express or implied
    warranty.  In no event will the authors be held liable for any damages
    arising from the use of this software.

    Permission is granted to anyone to use this software for any purpose,
    including commercial applications, and to alter it and redistribute it
    freely, subject to the following restrictions:

    1. The origin of this software must not be misrepresented; you must not
       claim that you wrote the original software. If you use this software
       in a product, an acknowledgment in the product documentation would be
       appreciated but is not required.
    2. Altered source versions must be plainly marked as such, and must not be
       misrepresented as being the original software.
    3. This notice may not be removed or altered from any source distribution.
      
*/



KMenuItem::KMenuItem()
{
	hMenu=0;
	listener=0;
	itemText=KString();
	enabled=true;
	checked=false;
	itemID=KPlatformUtil::GetInstance()->GenerateMenuItemID(this);
}

void KMenuItem::AddToMenu(HMENU hMenu)
{
	this->hMenu=hMenu;

	MENUITEMINFOW mii;
	ZeroMemory(&mii, sizeof(mii));

	mii.cbSize=sizeof(MENUITEMINFOW);
	mii.fMask=MIIM_DATA|MIIM_ID|MIIM_STATE|MIIM_TYPE;
	mii.fType=MFT_STRING;
	mii.dwTypeData=(LPWSTR)(const wchar_t*)itemText;
	mii.cch=lstrlenW((LPWSTR)(const wchar_t*)itemText);
	mii.fState=(enabled?MFS_ENABLED:MFS_DISABLED)|(checked?MFS_CHECKED:MFS_UNCHECKED);
	mii.wID=itemID;
	mii.dwItemData=(ULONG_PTR)this; // for future!

	InsertMenuItemW(hMenu,itemID,FALSE,&mii);

}

bool KMenuItem::IsChecked()
{
	return checked;
}

void KMenuItem::SetCheckedState(bool state)
{
	checked=state;
	if(hMenu) // it's alredy created menu item!
	{
		MENUITEMINFOW mii;
		ZeroMemory(&mii, sizeof(mii));

		mii.cbSize=sizeof(MENUITEMINFOW);
		mii.fMask=MIIM_STATE;
		mii.fState=checked?MFS_CHECKED:MFS_UNCHECKED;

		SetMenuItemInfoW(hMenu,itemID,FALSE,&mii);
	}
}

bool KMenuItem::IsEnabled()
{
	return enabled; 
}

void KMenuItem::SetEnabled(bool state)
{
	enabled=state;
	if(hMenu) // it's alredy created menu item!
	{
		MENUITEMINFOW mii;
		ZeroMemory(&mii, sizeof(mii));

		mii.cbSize=sizeof(MENUITEMINFOW);
		mii.fMask=MIIM_STATE;
		mii.fState=enabled?MFS_ENABLED:MFS_DISABLED;

		SetMenuItemInfoW(hMenu,itemID,FALSE,&mii);
	}
}

void KMenuItem::SetText(KString &text)
{
	itemText=text;
	if(hMenu) // it's alredy created menu item!
	{
		MENUITEMINFOW mii;
		ZeroMemory(&mii, sizeof(mii));

		mii.cbSize=sizeof(MENUITEMINFOW);
		mii.fMask=MIIM_TYPE;
		mii.fType=MFT_STRING;
		mii.dwTypeData=(LPWSTR)(const wchar_t*)itemText;
		mii.cch=lstrlenW((LPWSTR)(const wchar_t*)itemText);

		SetMenuItemInfoW(hMenu,itemID,FALSE,&mii);
	}
}

KString KMenuItem::GetText()
{
	return itemText;
}

UINT KMenuItem::GetItemID()
{
	return itemID;
}

HMENU KMenuItem::GetMenuHandle()
{
	return hMenu;
}

void KMenuItem::SetListener(KMenuItemListener *listener)
{
	this->listener=listener;
}

KMenuItemListener* KMenuItem::GetListener()
{
	return listener;
}

void KMenuItem::OnPress()
{
	if(listener)
		listener->OnMenuItemPress(this);
}

KMenuItem::~KMenuItem()
{
}


// =========== KMenuItemListener.cpp ===========

/*
    RFC - KMenuItemListener.cpp
    Copyright (C) 2013 CrownSoft
  
    This software is provided 'as-is', without any express or implied
    warranty.  In no event will the authors be held liable for any damages
    arising from the use of this software.

    Permission is granted to anyone to use this software for any purpose,
    including commercial applications, and to alter it and redistribute it
    freely, subject to the following restrictions:

    1. The origin of this software must not be misrepresented; you must not
       claim that you wrote the original software. If you use this software
       in a product, an acknowledgment in the product documentation would be
       appreciated but is not required.
    2. Altered source versions must be plainly marked as such, and must not be
       misrepresented as being the original software.
    3. This notice may not be removed or altered from any source distribution.
      
*/


KMenuItemListener::KMenuItemListener(){}

KMenuItemListener::~KMenuItemListener(){}

void KMenuItemListener::OnMenuItemPress(KMenuItem *menuItem){}

// =========== KNumericField.cpp ===========

/*
    RFC - KNumericField.cpp
    Copyright (C) 2013 CrownSoft
  
    This software is provided 'as-is', without any express or implied
    warranty.  In no event will the authors be held liable for any damages
    arising from the use of this software.

    Permission is granted to anyone to use this software for any purpose,
    including commercial applications, and to alter it and redistribute it
    freely, subject to the following restrictions:

    1. The origin of this software must not be misrepresented; you must not
       claim that you wrote the original software. If you use this software
       in a product, an acknowledgment in the product documentation would be
       appreciated but is not required.
    2. Altered source versions must be plainly marked as such, and must not be
       misrepresented as being the original software.
    3. This notice may not be removed or altered from any source distribution.
      
*/


KNumericField::KNumericField():KTextBox(false)
{
	SetStyle(WS_CHILD|WS_CLIPSIBLINGS|WS_TABSTOP|ES_AUTOHSCROLL|ES_NUMBER);
}

KNumericField::~KNumericField(){}

// =========== KPasswordBox.cpp ===========

/*
    RFC - KPasswordBox.cpp
    Copyright (C) 2013 CrownSoft
  
    This software is provided 'as-is', without any express or implied
    warranty.  In no event will the authors be held liable for any damages
    arising from the use of this software.

    Permission is granted to anyone to use this software for any purpose,
    including commercial applications, and to alter it and redistribute it
    freely, subject to the following restrictions:

    1. The origin of this software must not be misrepresented; you must not
       claim that you wrote the original software. If you use this software
       in a product, an acknowledgment in the product documentation would be
       appreciated but is not required.
    2. Altered source versions must be plainly marked as such, and must not be
       misrepresented as being the original software.
    3. This notice may not be removed or altered from any source distribution.
      
*/


KPasswordBox::KPasswordBox(bool readOnly):KTextBox(readOnly)
{
	pwdChar='*';
	SetStyle(compDwStyle|ES_PASSWORD);
}

void KPasswordBox::SetPasswordChar(char pwdChar)
{
	this->pwdChar=pwdChar;
	if(compHWND)
	{
		SendMessageW(compHWND,EM_SETPASSWORDCHAR,pwdChar,0);
		Repaint();
	}
}

char KPasswordBox::GetPasswordChar()
{
	return pwdChar;
}

bool KPasswordBox::CreateComponent()
{
	if(KTextBox::CreateComponent())
	{
		SendMessageW(compHWND,EM_SETPASSWORDCHAR,pwdChar,0);
		return true;
	}
	return false;
}

KPasswordBox::~KPasswordBox()
{
}

// =========== KProgressBar.cpp ===========

/*
    RFC - KProgressBar.cpp
    Copyright (C) 2013 CrownSoft
  
    This software is provided 'as-is', without any express or implied
    warranty.  In no event will the authors be held liable for any damages
    arising from the use of this software.

    Permission is granted to anyone to use this software for any purpose,
    including commercial applications, and to alter it and redistribute it
    freely, subject to the following restrictions:

    1. The origin of this software must not be misrepresented; you must not
       claim that you wrote the original software. If you use this software
       in a product, an acknowledgment in the product documentation would be
       appreciated but is not required.
    2. Altered source versions must be plainly marked as such, and must not be
       misrepresented as being the original software.
    3. This notice may not be removed or altered from any source distribution.
      
*/


KProgressBar::KProgressBar(bool smooth,bool vertical)
{
	value=0;

	compClassName=KString(PROGRESS_CLASSW);

	SetPosition(0,0);
	SetSize(100,20);
	SetStyle(WS_CHILD|WS_CLIPSIBLINGS);
	SetExStyle(WS_EX_WINDOWEDGE);

	if(smooth)
		SetStyle(GetStyle()|PBS_SMOOTH);

	if(vertical)
		SetStyle(GetStyle()|PBS_VERTICAL);
}

int KProgressBar::GetValue()
{
	return value;
}

void KProgressBar::SetValue(int value)
{
	this->value=value;

	if(compHWND)
		SendMessageW(compHWND,PBM_SETPOS,value,0);
}

bool KProgressBar::CreateComponent()
{
	if(!compParentHWND) // user must specify parent handle!
		return false;

	CreateRFCComponent(this); // we dont need to register PROGRESS_CLASSW class!

	if(compHWND)
	{
		SendMessageW(compHWND,PBM_SETRANGE,0,MAKELPARAM(0,100)); // set range between 0-100
		SendMessageW(compHWND,PBM_SETPOS,value,0); // set current value!

		EnableWindow(compHWND,compEnabled);

		if(this->IsVisible())
			this->SetVisible(true);
		return true;
	}
	return false;	
}

KProgressBar::~KProgressBar()
{
}

// =========== KPushButton.cpp ===========

/*
    RFC - KPushButton.cpp
    Copyright (C) 2013 CrownSoft
  
    This software is provided 'as-is', without any express or implied
    warranty.  In no event will the authors be held liable for any damages
    arising from the use of this software.

    Permission is granted to anyone to use this software for any purpose,
    including commercial applications, and to alter it and redistribute it
    freely, subject to the following restrictions:

    1. The origin of this software must not be misrepresented; you must not
       claim that you wrote the original software. If you use this software
       in a product, an acknowledgment in the product documentation would be
       appreciated but is not required.
    2. Altered source versions must be plainly marked as such, and must not be
       misrepresented as being the original software.
    3. This notice may not be removed or altered from any source distribution.
      
*/


KPushButton::KPushButton()
{
	SetText(KString(L"PushButton"));
	SetStyle(WS_CHILD|WS_CLIPSIBLINGS|BS_AUTOCHECKBOX|BS_PUSHLIKE|BS_NOTIFY|WS_TABSTOP);
}

KPushButton::~KPushButton()
{
}

// =========== KRadioButton.cpp ===========

/*
    RFC - KRadioButton.cpp
    Copyright (C) 2013 CrownSoft
  
    This software is provided 'as-is', without any express or implied
    warranty.  In no event will the authors be held liable for any damages
    arising from the use of this software.

    Permission is granted to anyone to use this software for any purpose,
    including commercial applications, and to alter it and redistribute it
    freely, subject to the following restrictions:

    1. The origin of this software must not be misrepresented; you must not
       claim that you wrote the original software. If you use this software
       in a product, an acknowledgment in the product documentation would be
       appreciated but is not required.
    2. Altered source versions must be plainly marked as such, and must not be
       misrepresented as being the original software.
    3. This notice may not be removed or altered from any source distribution.
      
*/


KRadioButton::KRadioButton()
{
	SetText(KString(L"RadioButton"));
	SetStyle(WS_CHILD|WS_CLIPSIBLINGS|BS_RADIOBUTTON|BS_NOTIFY|WS_TABSTOP);
}

KRadioButton::~KRadioButton()
{
}

// =========== KTextArea.cpp ===========

/*
    RFC - KTextArea.cpp
    Copyright (C) 2013 CrownSoft
  
    This software is provided 'as-is', without any express or implied
    warranty.  In no event will the authors be held liable for any damages
    arising from the use of this software.

    Permission is granted to anyone to use this software for any purpose,
    including commercial applications, and to alter it and redistribute it
    freely, subject to the following restrictions:

    1. The origin of this software must not be misrepresented; you must not
       claim that you wrote the original software. If you use this software
       in a product, an acknowledgment in the product documentation would be
       appreciated but is not required.
    2. Altered source versions must be plainly marked as such, and must not be
       misrepresented as being the original software.
    3. This notice may not be removed or altered from any source distribution.
      
*/


KTextArea::KTextArea(bool autoScroll,bool readOnly):KTextBox(readOnly)
{
	SetSize(200,100);
	SetStyle(compDwStyle|ES_MULTILINE);

	if(autoScroll)
		SetStyle(compDwStyle|ES_AUTOHSCROLL|ES_AUTOVSCROLL);
	else
		SetStyle(compDwStyle|WS_HSCROLL|WS_VSCROLL);
}

KTextArea::~KTextArea()
{
}

// =========== KTextBox.cpp ===========

/*
    RFC - KTextBox.cpp
    Copyright (C) 2013 CrownSoft
  
    This software is provided 'as-is', without any express or implied
    warranty.  In no event will the authors be held liable for any damages
    arising from the use of this software.

    Permission is granted to anyone to use this software for any purpose,
    including commercial applications, and to alter it and redistribute it
    freely, subject to the following restrictions:

    1. The origin of this software must not be misrepresented; you must not
       claim that you wrote the original software. If you use this software
       in a product, an acknowledgment in the product documentation would be
       appreciated but is not required.
    2. Altered source versions must be plainly marked as such, and must not be
       misrepresented as being the original software.
    3. This notice may not be removed or altered from any source distribution.
      
*/


KTextBox::KTextBox(bool readOnly)
{
	compClassName=KString(L"EDIT");

	SetSize(100,20);
	SetPosition(0,0);
	SetStyle(WS_CHILD|WS_CLIPSIBLINGS|WS_TABSTOP|ES_AUTOHSCROLL);
	if(readOnly)
		SetStyle(WS_CHILD|WS_CLIPSIBLINGS|WS_TABSTOP|ES_READONLY|ES_AUTOHSCROLL);

	SetExStyle(WS_EX_CLIENTEDGE|WS_EX_WINDOWEDGE);
}

KString KTextBox::GetText()
{
	if(compHWND)
	{
		int length=GetWindowTextLengthW(compHWND);
		if(length)
		{
			int size=(length+1)*sizeof(wchar_t);
			wchar_t *text=(wchar_t*)malloc(size);
			GetWindowTextW(compHWND,text,size);
			compText=KString(text);
			free(text);
		}else
		{
			compText=KString();
		}
	}
	return compText;
}


bool KTextBox::CreateComponent()
{
	if(!compParentHWND) // user must specify parent handle!
		return false;

	CreateRFCComponent(this); // we dont need to register EDIT class!

	if(compHWND)
	{
		SendMessageW(compHWND,WM_SETFONT,(WPARAM)compFont->GetFontHandle(),MAKELPARAM(true, 0)); // set default font!

		EnableWindow(compHWND,compEnabled);

		if(this->IsVisible())
			this->SetVisible(true);
		return true;
	}
	return false;
}

KTextBox::~KTextBox()
{
}

// =========== KTrackBar.cpp ===========

/*
    RFC - KTrackBar.cpp
    Copyright (C) 2013 CrownSoft
  
    This software is provided 'as-is', without any express or implied
    warranty.  In no event will the authors be held liable for any damages
    arising from the use of this software.

    Permission is granted to anyone to use this software for any purpose,
    including commercial applications, and to alter it and redistribute it
    freely, subject to the following restrictions:

    1. The origin of this software must not be misrepresented; you must not
       claim that you wrote the original software. If you use this software
       in a product, an acknowledgment in the product documentation would be
       appreciated but is not required.
    2. Altered source versions must be plainly marked as such, and must not be
       misrepresented as being the original software.
    3. This notice may not be removed or altered from any source distribution.
      
*/



KTrackBar::KTrackBar(bool showTicks,bool vertical)
{
	listener=0;
	rangeMin=0;
	rangeMax=100;
	value=0;

	SetSize(100,25);
	SetPosition(0,0);
	SetStyle(WS_TABSTOP|WS_CHILD|WS_CLIPSIBLINGS);
	SetExStyle(WS_EX_WINDOWEDGE);

	SetStyle(compDwStyle|(showTicks?TBS_AUTOTICKS:TBS_NOTICKS));
	SetStyle(compDwStyle|(vertical?TBS_VERT:TBS_HORZ));

	compClassName=KString(TRACKBAR_CLASSW);
}

void KTrackBar::SetRange(int min,int max)
{
	rangeMin=min;
	rangeMax=max;
	if(compHWND)
		SendMessageW(compHWND,TBM_SETRANGE,TRUE,(LPARAM) MAKELONG(min,max));	
}

void KTrackBar::SetValue(int value)
{
	this->value=value;
	if(compHWND)
		SendMessageW(compHWND,TBM_SETPOS,TRUE,(LPARAM)value);
}

void KTrackBar::OnChange()
{
	value=(int)SendMessageW(compHWND,TBM_GETPOS,0,0);
	if(listener)
		listener->OnTrackBarChange(this);
}

void KTrackBar::SetListener(KTrackBarListener *listener)
{
	this->listener=listener;
}

int KTrackBar::GetValue()
{
	return value;
}

bool KTrackBar::CreateComponent()
{
	if(!compParentHWND) // user must specify parent handle!
		return false;

	CreateRFCComponent(this); // we dont need to register TRACKBAR_CLASSW class!

	if(compHWND)
	{
		SendMessageW(compHWND,WM_SETFONT,(WPARAM)compFont->GetFontHandle(),MAKELPARAM(true, 0)); // set default font!

		EnableWindow(compHWND,compEnabled);

		SendMessageW(compHWND,TBM_SETRANGE,TRUE,(LPARAM) MAKELONG(rangeMin,rangeMax));	
		SendMessageW(compHWND,TBM_SETPOS,TRUE,(LPARAM)value);

		if(this->IsVisible())
			this->SetVisible(true);
		return true;
	}

	return false;
}

KTrackBar::~KTrackBar()
{
}


// =========== KTrackBarListener.cpp ===========

/*
    RFC - KTrackBarListener.cpp
    Copyright (C) 2013 CrownSoft
  
    This software is provided 'as-is', without any express or implied
    warranty.  In no event will the authors be held liable for any damages
    arising from the use of this software.

    Permission is granted to anyone to use this software for any purpose,
    including commercial applications, and to alter it and redistribute it
    freely, subject to the following restrictions:

    1. The origin of this software must not be misrepresented; you must not
       claim that you wrote the original software. If you use this software
       in a product, an acknowledgment in the product documentation would be
       appreciated but is not required.
    2. Altered source versions must be plainly marked as such, and must not be
       misrepresented as being the original software.
    3. This notice may not be removed or altered from any source distribution.
      
*/


KTrackBarListener::KTrackBarListener(){}

KTrackBarListener::~KTrackBarListener(){}

void KTrackBarListener::OnTrackBarChange(KTrackBar *trackBar){}

// =========== KWindow.cpp ===========

/*
    RFC - KWindow.cpp
    Copyright (C) 2013 CrownSoft
  
    This software is provided 'as-is', without any express or implied
    warranty.  In no event will the authors be held liable for any damages
    arising from the use of this software.

    Permission is granted to anyone to use this software for any purpose,
    including commercial applications, and to alter it and redistribute it
    freely, subject to the following restrictions:

    1. The origin of this software must not be misrepresented; you must not
       claim that you wrote the original software. If you use this software
       in a product, an acknowledgment in the product documentation would be
       appreciated but is not required.
    2. Altered source versions must be plainly marked as such, and must not be
       misrepresented as being the original software.
    3. This notice may not be removed or altered from any source distribution.
      
*/


KWindow::KWindow()
{
	SetText(KString(L"KWindow"));
	SetSize(400,200);
	SetVisible(false);
	SetStyle(WS_POPUP);
	SetExStyle(WS_EX_APPWINDOW|WS_EX_ACCEPTFILES|WS_EX_CONTROLPARENT);
	wc.style=CS_OWNDC|CS_HREDRAW|CS_VREDRAW;
}

void KWindow::SetIcon(KIcon *icon)
{
	SetClassLongW(compHWND,GCL_HICON,(LONG)icon->GetHandle());
}

void KWindow::OnClose()
{
	DestroyWindow(compHWND);
}

void KWindow::OnDestroy()
{
	PostQuitMessage(0);
}

void KWindow::CenterScreen()
{
	SetPosition((GetSystemMetrics(SM_CXSCREEN)-compWidth)/2,(GetSystemMetrics(SM_CYSCREEN)-compHeight)/2);
}

bool KWindow::AddComponent(KComponent *component)
{
	if(component)
	{
		if(compHWND)
		{
			component->SetParentHWND(compHWND);
			return component->CreateComponent();
		}
	}
	return false;
}


LRESULT KWindow::WindowProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	static const wchar_t* RFCPropText_Object=L"RFC";
	static const wchar_t* RFCPropText_ClsName=L"RFCClsName";

	switch(msg)
	{
		case WM_COMMAND:
			{
				if(HIWORD(wParam)==BN_CLICKED) // button, checkbox, radio button or menu clicked event!
				{
					if(lParam)
					{
						KButton *btn=(KButton*)GetPropW((HWND)lParam, RFCPropText_Object);
						if(btn) // button, checkbox or radio button!
						{
							btn->OnPress();
							break;
						}
					}else // its menu item! unfortunately windows does not send menu handle with clicked event!
					{
						KMenuItem *menuItem=KPlatformUtil::GetInstance()->GetMenuItemByID(LOWORD(wParam));
						if(menuItem)
						{
							menuItem->OnPress();
							break;
						}
					}
				}else if(HIWORD(wParam)==LBN_SELCHANGE) // listbox sel change! (this msg also pops for combo)
				{
					wchar_t* clsName=(wchar_t*)GetPropW((HWND)lParam, RFCPropText_ClsName);
					if(wcscmp(clsName,L"COMBOBOX")!=0) // ignore combobox
					{
						KListBox *listBox=(KListBox*)GetPropW((HWND)lParam, RFCPropText_Object);
						if(listBox)
						{
							listBox->OnItemSelect();
							break;
						}
					}
				}else if(HIWORD(wParam)==CBN_SELENDOK) // combobox sel change!
				{
					KComboBox *comboBox=(KComboBox*)GetPropW((HWND)lParam, RFCPropText_Object);
					if(comboBox)
					{
						comboBox->OnItemSelect();
						break;
					}
				}
			}
			return KComponent::WindowProc(hwnd,msg,wParam,lParam);

		case WM_HSCROLL:
		case WM_VSCROLL:
			{
				int nScrollCode = (int)LOWORD(wParam);

				if( (TB_THUMBTRACK==nScrollCode)||(TB_LINEDOWN==nScrollCode) || (TB_LINEUP==nScrollCode) || (TB_BOTTOM==nScrollCode) || (TB_TOP==nScrollCode) || (TB_PAGEUP==nScrollCode) || (TB_PAGEDOWN==nScrollCode) ) // its trackbar!
				{
					KTrackBar *trackBar=(KTrackBar*)GetPropW((HWND)lParam, RFCPropText_Object);
					if(trackBar)
					{
						trackBar->OnChange();
						break;
					}
				}
			}
			return KComponent::WindowProc(hwnd,msg,wParam,lParam);

		case WM_TIMER:
			{
				KTimer *timer=KPlatformUtil::GetInstance()->GetTimerByID((UINT)wParam);
				if(timer)
				{
					timer->OnTimer();
					break;
				}
			}
			return KComponent::WindowProc(hwnd,msg,wParam,lParam);

		case WM_CLOSE:
			OnClose();
			break;
		case WM_DESTROY:
			OnDestroy();
			break;

		default:
			return KComponent::WindowProc(hwnd,msg,wParam,lParam);
	}
	return 0;
}


KWindow::~KWindow()
{

}

// =========== KWindowTypes.cpp ===========

/*
RFC - KWindowTypes.cpp
Copyright (C) 2013 CrownSoft

This software is provided 'as-is', without any express or implied
warranty.  In no event will the authors be held liable for any damages
arising from the use of this software.

Permission is granted to anyone to use this software for any purpose,
including commercial applications, and to alter it and redistribute it
freely, subject to the following restrictions:

1. The origin of this software must not be misrepresented; you must not
claim that you wrote the original software. If you use this software
in a product, an acknowledgment in the product documentation would be
appreciated but is not required.
2. Altered source versions must be plainly marked as such, and must not be
misrepresented as being the original software.
3. This notice may not be removed or altered from any source distribution.

*/



KHotPluggedDialog::KHotPluggedDialog(){}


void KHotPluggedDialog::OnClose()
{
	EndDialog(compHWND,0);
}

void KHotPluggedDialog::OnDestroy(){}

KHotPluggedDialog::~KHotPluggedDialog(){}


KOverlappedWindow::KOverlappedWindow()
{
	SetText(KString(L"KOverlapped Window"));
	SetStyle(WS_OVERLAPPEDWINDOW);
}

KOverlappedWindow::~KOverlappedWindow(){}


KFrame::KFrame()
{
	SetText(KString(L"KFrame"));
	SetStyle(WS_POPUP|WS_CAPTION|WS_SYSMENU|WS_MINIMIZEBOX);
}

KFrame::~KFrame(){}



KDialog::KDialog()
{
	SetText(KString(L"KDialog"));
	SetStyle(WS_POPUP|WS_CAPTION|WS_SYSMENU);
}

KDialog::~KDialog(){}



KToolWindow::KToolWindow()
{
	SetText(KString(L"KTool Window"));
	SetStyle(WS_OVERLAPPED|WS_SYSMENU);
	SetExStyle(WS_EX_TOOLWINDOW);
}

KToolWindow::~KToolWindow(){}

// =========== KBitmap.cpp ===========

/*
    RFC - KBitmap.cpp
    Copyright (C) 2013 CrownSoft
  
    This software is provided 'as-is', without any express or implied
    warranty.  In no event will the authors be held liable for any damages
    arising from the use of this software.

    Permission is granted to anyone to use this software for any purpose,
    including commercial applications, and to alter it and redistribute it
    freely, subject to the following restrictions:

    1. The origin of this software must not be misrepresented; you must not
       claim that you wrote the original software. If you use this software
       in a product, an acknowledgment in the product documentation would be
       appreciated but is not required.
    2. Altered source versions must be plainly marked as such, and must not be
       misrepresented as being the original software.
    3. This notice may not be removed or altered from any source distribution.
      
*/


KBitmap::KBitmap()
{
	hBitmap=0;
	appInstance=KPlatformUtil::GetInstance()->GetAppInstance();
}

bool KBitmap::LoadFromResource(WORD resourceID)
{
	hBitmap=(HBITMAP)LoadImageW(appInstance,MAKEINTRESOURCEW(resourceID),IMAGE_BITMAP,0,0,LR_DEFAULTSIZE|LR_DEFAULTCOLOR);
	if(hBitmap)
		return true;	
	return false;
}

bool KBitmap::LoadFromFile(KString &filePath)
{
	hBitmap=(HBITMAP)LoadImageW(appInstance,(const wchar_t*)filePath,IMAGE_BITMAP,0,0,LR_LOADFROMFILE|LR_DEFAULTSIZE|LR_DEFAULTCOLOR);
	if(hBitmap)
		return true;	
	return false;
}

HBITMAP KBitmap::GetHandle()
{
	return hBitmap;
}

KBitmap::~KBitmap()
{
	if(hBitmap)
		DeleteObject(hBitmap);
}

// =========== KCursor.cpp ===========

/*
    RFC - KCursor.cpp
    Copyright (C) 2013 CrownSoft
  
    This software is provided 'as-is', without any express or implied
    warranty.  In no event will the authors be held liable for any damages
    arising from the use of this software.

    Permission is granted to anyone to use this software for any purpose,
    including commercial applications, and to alter it and redistribute it
    freely, subject to the following restrictions:

    1. The origin of this software must not be misrepresented; you must not
       claim that you wrote the original software. If you use this software
       in a product, an acknowledgment in the product documentation would be
       appreciated but is not required.
    2. Altered source versions must be plainly marked as such, and must not be
       misrepresented as being the original software.
    3. This notice may not be removed or altered from any source distribution.
      
*/


KCursor::KCursor()
{
	hCursor=0;
	appInstance=KPlatformUtil::GetInstance()->GetAppInstance();
}

bool KCursor::LoadFromResource(WORD resourceID)
{
	hCursor=(HCURSOR)LoadImageW(appInstance,MAKEINTRESOURCEW(resourceID),IMAGE_CURSOR,0,0,LR_DEFAULTSIZE|LR_DEFAULTCOLOR);
	if(hCursor)
		return true;	
	return false;
}

bool KCursor::LoadFromFile(KString &filePath)
{
	hCursor=(HCURSOR)LoadImageW(appInstance,(const wchar_t*)filePath,IMAGE_CURSOR,0,0,LR_LOADFROMFILE|LR_DEFAULTSIZE|LR_DEFAULTCOLOR);
	if(hCursor)
		return true;	
	return false;
}

HCURSOR KCursor::GetHandle()
{
	return hCursor;
}

KCursor::~KCursor()
{
	if(hCursor)
		DestroyCursor(hCursor);
}

// =========== KFont.cpp ===========

/*
    RFC - KFont.cpp
    Copyright (C) 2013 CrownSoft
  
    This software is provided 'as-is', without any express or implied
    warranty.  In no event will the authors be held liable for any damages
    arising from the use of this software.

    Permission is granted to anyone to use this software for any purpose,
    including commercial applications, and to alter it and redistribute it
    freely, subject to the following restrictions:

    1. The origin of this software must not be misrepresented; you must not
       claim that you wrote the original software. If you use this software
       in a product, an acknowledgment in the product documentation would be
       appreciated but is not required.
    2. Altered source versions must be plainly marked as such, and must not be
       misrepresented as being the original software.
    3. This notice may not be removed or altered from any source distribution.
      
*/


KFont* KFont::defaultInstance=0;

KFont::KFont()
{
	hFont=(HFONT)GetStockObject(DEFAULT_GUI_FONT);
	customFont=false;
}

KFont::KFont(KString &face,int size,bool bold,bool italic)
{
	hFont=CreateFontW(size, 0, 0, 0, bold?FW_BOLD:FW_NORMAL, italic?TRUE:FALSE, 0, 0, DEFAULT_CHARSET, 0, 0, 0,VARIABLE_PITCH | FF_DONTCARE,(const wchar_t*)face); 
	if(hFont)
		customFont=true;
}

KFont* KFont::GetDefaultFont()
{
	if(KFont::defaultInstance)
		return KFont::defaultInstance;
	KFont::defaultInstance=new KFont();
	return KFont::defaultInstance;
}

HFONT KFont::GetFontHandle()
{
	return hFont;
}

KFont::~KFont()
{
	if(customFont)
		DeleteObject(hFont);
}

// =========== KIcon.cpp ===========

/*
    RFC - KIcon.cpp
    Copyright (C) 2013 CrownSoft
  
    This software is provided 'as-is', without any express or implied
    warranty.  In no event will the authors be held liable for any damages
    arising from the use of this software.

    Permission is granted to anyone to use this software for any purpose,
    including commercial applications, and to alter it and redistribute it
    freely, subject to the following restrictions:

    1. The origin of this software must not be misrepresented; you must not
       claim that you wrote the original software. If you use this software
       in a product, an acknowledgment in the product documentation would be
       appreciated but is not required.
    2. Altered source versions must be plainly marked as such, and must not be
       misrepresented as being the original software.
    3. This notice may not be removed or altered from any source distribution.
      
*/


KIcon::KIcon()
{
	hIcon=0;
	appInstance=KPlatformUtil::GetInstance()->GetAppInstance();
}

bool KIcon::LoadFromResource(WORD resourceID)
{
	hIcon=(HICON)LoadImageW(appInstance,MAKEINTRESOURCEW(resourceID),IMAGE_ICON,0,0,LR_DEFAULTSIZE|LR_DEFAULTCOLOR);
	if(hIcon)
		return true;	
	return false;
}

bool KIcon::LoadFromFile(KString &filePath)
{
	hIcon=(HICON)LoadImageW(appInstance,(const wchar_t*)filePath,IMAGE_ICON,0,0,LR_LOADFROMFILE|LR_DEFAULTSIZE|LR_DEFAULTCOLOR);
	if(hIcon)
		return true;	
	return false;
}

HICON KIcon::GetHandle()
{
	return hIcon;
}

KIcon::~KIcon()
{
	if(hIcon)
		DestroyIcon(hIcon);
}